/*
 *  ========================================================================
 *  DIScrete event baSed Energy Consumption simulaTor 
 *    					             for Clouds and Federations (DISSECT-CF)
 *  ========================================================================
 *  
 *  This file is part of DISSECT-CF.
 *  
 *  DISSECT-CF is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or (at
 *  your option) any later version.
 *  
 *  DISSECT-CF is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
 *  General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with DISSECT-CF.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  (C) Copyright 2013, Gabor Kecskemeti (gkecskem@dps.uibk.ac.at,
 *   									  kecskemeti.gabor@sztaki.mta.hu)
 */

package hu.mta.sztaki.lpds.cloud.simulator.iaas;

import hu.mta.sztaki.lpds.cloud.simulator.storage.Repository;
import hu.mta.sztaki.lpds.cloud.simulator.storage.VirtualAppliance;
import hu.mta.sztaki.lpds.cloud.simulator.util.FastArray;

import java.util.List;
import java.util.Vector;

public class IaaSService implements VMManager<IaaSService> {

	public class IaaSHandlingException extends Exception {

		private static final long serialVersionUID = 2580735547805541590L;

		public IaaSHandlingException(final String s) {
			super(s);
		}
	}

	FastArray<PhysicalMachine> machines = new FastArray<PhysicalMachine>(
			new PhysicalMachine[50]);

	FastArray<Repository> repositories = new FastArray<Repository>(
			new Repository[5]);

	public IaaSService() {
	}

	@Override
	public void migrateVM(final VirtualMachine vm, final IaaSService target) {
	}

	@Override
	public void reallocateResources(final VirtualMachine vm,
			final ResourceConstraints newresources) {
	}

	@Override
	public VirtualMachine requestVM(final VirtualAppliance va, ResourceConstraints rc, Repository vaSource) {
		return null;
	}

	@Override
	public void terminateVM(final VirtualMachine vm, boolean killtasks) {
	}

	@Override
	public List<VirtualMachine> listVMs() {
		final Vector<VirtualMachine> completeList = new Vector<VirtualMachine>();
		machines.iterate(new FastArray.ForEachAction<PhysicalMachine>() {
			@Override
			public void eval(final PhysicalMachine element) {
				completeList.addAll(element.listVMs());
			}
		});
		return completeList;
	}

	public void registerHost(final PhysicalMachine pm) {
		machines.add(pm);
	}

	public void deregisterHost(final PhysicalMachine pm) throws IaaSHandlingException {
		machines.remove(pm);
	}

	public List<PhysicalMachine> listHosts() {
		return machines.asList();
	}

	public void registerRepository(final Repository r) {
		repositories.add(r);
	}

	public void deregisterRepository(final Repository r) throws IaaSHandlingException {
		repositories.remove(r);
	}

	public List<Repository> listRepositories() {
		return repositories.asList();
	}
}
